#!/bin/bash
PY="python3"
for orig in $@
do
	prog=${orig%%"-sol"}
	INSTANCE="data/$prog?.in.txt"
	echo "*** Testing $prog ***"
	# Use data files from $prog.test.txt, if it exists
	if [ -e "data/$prog.test.txt" ]; then
		echo "Using test suite $prog.test.txt"
		INSTANCE= # reset
		while IFS= read -r LINE
		do
			[[ $LINE =~ ^#.* ]] && continue  # Salta le righe che iniziano con '#'
			for PATTERN in $LINE
			do
				INSTANCE="${INSTANCE}"$("find" data -name $PATTERN | sort)" "
			done
		done <"data/$prog.test.txt"
	fi
	for i in $INSTANCE
	do 
		o=${i%%.*}".out.txt"
		# Default checker is diff
		CHECKER="diff -a -b -q - $o"
		# Use custom checker, if available
		if [ -e "$prog""_check.py" ]; then
			echo "* Custom checker found"
			CHECKER="$PY $prog""_check.py"
		fi
		CHECK=$($PY $orig".py" < $i | $CHECKER 3< $i 4< $o)
		if [ $? -ne 0 ]; then
			echo -e "$orig.py  \t: $i   \t[FAILED] <---"
		else
			echo -e "$orig.py  \t: $i   \t[passed]"
		fi
	done
done
